#include "defines.h"
#include "m_flyer.h"

static int  nextmove;      // Used for start/stop frames

static int  sound_sight;
static int  sound_idle;
static int  sound_pain1;
static int  sound_pain2;
static int  sound_slash;
static int  sound_sproing;
static int  sound_die;

void flyer_check_melee(edict_t *self);
void flyer_loop_melee(edict_t *self);
void flyer_melee(edict_t *self);
void flyer_setstart(edict_t *self);
void flyer_stand(edict_t *self);
void flyer_nextmove(edict_t *self);

//============================================================
void flyer_sight(edict_t *self, edict_t *other) {
	gi.sound(self, CHAN_VOICE, sound_sight, 1, ATTN_NORM, 0);
}

//============================================================
void flyer_idle(edict_t *self) {
	gi.sound(self, CHAN_VOICE, sound_idle, 1, ATTN_IDLE, 0);
}

//============================================================
void flyer_pop_blades(edict_t *self) {
	gi.sound(self, CHAN_VOICE, sound_sproing, 1, ATTN_NORM, 0);
}

//============================================================
mframe_t flyer_frames_stand [] = {
	ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL,
		ai_stand, 0, NULL
};
mmove_t  flyer_move_stand = {FRAME_stand01, FRAME_stand45, flyer_frames_stand, NULL};

//============================================================
mframe_t flyer_frames_walk [] = {
	ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL,
		ai_walk, 5, NULL
};
mmove_t  flyer_move_walk = {FRAME_stand01, FRAME_stand45, flyer_frames_walk, NULL};

//============================================================
mframe_t flyer_frames_run [] = {
	ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL,
		ai_run, 10, NULL
};
mmove_t  flyer_move_run = {FRAME_stand01, FRAME_stand45, flyer_frames_run, NULL};

//============================================================
void flyer_run(edict_t *self) {
	if (self->monsterinfo.aiflags & AI_STAND_GROUND)
		self->monsterinfo.currentmove = &flyer_move_stand;
	else
		self->monsterinfo.currentmove = &flyer_move_run;
}

//============================================================
void flyer_walk(edict_t *self) {
	self->monsterinfo.currentmove = &flyer_move_walk;
}

//============================================================
void flyer_stand(edict_t *self) {
	self->monsterinfo.currentmove = &flyer_move_stand;
}

//============================================================
mframe_t flyer_frames_start [] = {
    ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  flyer_nextmove
};
mmove_t flyer_move_start = {FRAME_start01, FRAME_start06, flyer_frames_start, NULL};

//============================================================
mframe_t flyer_frames_stop [] = {
    ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  NULL,
		ai_move, 0,  flyer_nextmove
};
mmove_t flyer_move_stop = {FRAME_stop01, FRAME_stop07, flyer_frames_stop, NULL};

//============================================================
void flyer_stop(edict_t *self) {
    self->monsterinfo.currentmove = &flyer_move_stop;
}

//============================================================
void flyer_start(edict_t *self) {
    self->monsterinfo.currentmove = &flyer_move_start;
}

//============================================================
mframe_t flyer_frames_rollright [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_rollright = {FRAME_rollr01, FRAME_rollr09, flyer_frames_rollright, NULL};

//============================================================
mframe_t flyer_frames_rollleft [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_rollleft = {FRAME_rollf01, FRAME_rollf09, flyer_frames_rollleft, NULL};

//============================================================
mframe_t flyer_frames_pain3 [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_pain3 = {FRAME_pain301, FRAME_pain304, flyer_frames_pain3, flyer_run};

//============================================================
mframe_t flyer_frames_pain2 [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_pain2 = {FRAME_pain201, FRAME_pain204, flyer_frames_pain2, flyer_run};

//============================================================
mframe_t flyer_frames_pain1 [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_pain1 = {FRAME_pain101, FRAME_pain109, flyer_frames_pain1, flyer_run};

//============================================================
mframe_t flyer_frames_defense [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,    // Hold this frame
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_defense = {FRAME_defens01, FRAME_defens06, flyer_frames_defense, NULL};

//============================================================
mframe_t flyer_frames_bankright [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_bankright = {FRAME_bankr01, FRAME_bankr07, flyer_frames_bankright, NULL};

//============================================================
mframe_t flyer_frames_bankleft [] = {
    ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL,
		ai_move, 0, NULL
};
mmove_t flyer_move_bankleft = {FRAME_bankl01, FRAME_bankl07, flyer_frames_bankleft, NULL};

void Chaingun_Fire(edict_t *ent);

//===========================================================
void flyer_fire(edict_t *self, int flash_number) {
	vec3_t start, forward, right, end, dir;
	int effect=EF_NONE;
	
	if ((self->s.frame == FRAME_attak204)
		|| (self->s.frame == FRAME_attak207)
		||(self->s.frame == FRAME_attak210))
		effect = EF_HYPERBLASTER;
	
	AngleVectors(self->s.angles, forward, right, NULL);
	G_ProjectSource(self->s.origin, monster_flash_offset[flash_number], forward, right, start);
	VectorCopy(self->enemy->s.origin, end);
	end[2] += self->enemy->viewheight;
	VectorSubtract(end, start, dir);
	
	if (self->rider)
		monster_fire_chaingun(self, start, dir, 6, 4, DEFAULT_BULLET_HSPREAD, DEFAULT_BULLET_VSPREAD);
	else
		monster_fire_blaster(self, start, dir, 1, 1000, flash_number, effect);
}

//============================================================
void flyer_fireleft(edict_t *self) {
	flyer_fire(self, MZ2_FLYER_BLASTER_1);
}

//============================================================
void flyer_fireright(edict_t *self) {
	flyer_fire(self, MZ2_FLYER_BLASTER_2);
}

//============================================================
mframe_t flyer_frames_attack2 [] = {
    ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, -10, flyer_fireleft,     // left gun
		ai_charge, -10, flyer_fireright,    // right gun
		ai_charge, -10, flyer_fireleft,     // left gun
		ai_charge, -10, flyer_fireright,    // right gun
		ai_charge, -10, flyer_fireleft,     // left gun
		ai_charge, -10, flyer_fireright,    // right gun
		ai_charge, -10, flyer_fireleft,     // left gun
		ai_charge, -10, flyer_fireright,    // right gun
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL
};
mmove_t flyer_move_attack2 = {FRAME_attak201, FRAME_attak217, flyer_frames_attack2, flyer_run};

//============================================================
void flyer_slash_left(edict_t *self) {
	vec3_t  aim;
	
	VectorSet(aim, MELEE_DISTANCE, self->mins[0], 0);
	fire_hit(self, aim, 5, 0);
	gi.sound(self, CHAN_WEAPON, sound_slash, 1, ATTN_NORM, 0);
}

//============================================================
void flyer_slash_right(edict_t *self) {
	vec3_t  aim;
	
	VectorSet(aim, MELEE_DISTANCE, self->maxs[0], 0);
	fire_hit(self, aim, 5, 0);
	gi.sound(self, CHAN_WEAPON, sound_slash, 1, ATTN_NORM, 0);
}

//============================================================
mframe_t flyer_frames_start_melee [] = {
    ai_charge, 0, flyer_pop_blades,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL
};
mmove_t flyer_move_start_melee = {FRAME_attak101, FRAME_attak106, flyer_frames_start_melee, flyer_loop_melee};

//============================================================
mframe_t flyer_frames_end_melee [] = {
    ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL
};
mmove_t flyer_move_end_melee = {FRAME_attak119, FRAME_attak121, flyer_frames_end_melee, flyer_run};

//============================================================
mframe_t flyer_frames_loop_melee [] = {
    ai_charge, 0, NULL,    // Loop Start
		ai_charge, 0, NULL,
		ai_charge, 0, flyer_slash_left,    // Left Wing Strike
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, flyer_slash_right,  // Right Wing Strike
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL,
		ai_charge, 0, NULL    // Loop Ends
		
};
mmove_t flyer_move_loop_melee = {FRAME_attak107, FRAME_attak118, flyer_frames_loop_melee, flyer_check_melee};

//============================================================
void flyer_loop_melee(edict_t *self) {
	self->monsterinfo.currentmove = &flyer_move_loop_melee;
}

//============================================================
void flyer_attack(edict_t *self) {
	self->monsterinfo.currentmove = &flyer_move_attack2;
}

//============================================================
void flyer_setstart(edict_t *self) {
	nextmove = ACTION_run;
	self->monsterinfo.currentmove = &flyer_move_start;
}

//============================================================
void flyer_nextmove(edict_t *self) {
	if (nextmove == ACTION_attack1)
		self->monsterinfo.currentmove = &flyer_move_start_melee;
	else if (nextmove == ACTION_attack2)
		self->monsterinfo.currentmove = &flyer_move_attack2;
	else if (nextmove == ACTION_run)
		self->monsterinfo.currentmove = &flyer_move_run;
}

//============================================================
void flyer_melee(edict_t *self) {
	self->monsterinfo.currentmove = &flyer_move_start_melee;
}

//============================================================
void flyer_check_melee(edict_t *self) {
	if (range(self, self->enemy) == RANGE_MELEE)
		if (random() <= 0.8)
			self->monsterinfo.currentmove = &flyer_move_loop_melee;
		else
			self->monsterinfo.currentmove = &flyer_move_end_melee;
		else
			self->monsterinfo.currentmove = &flyer_move_end_melee;
}

//============================================================
void flyer_pain(edict_t *self, edict_t *other, float kick, int damage) {
	int n;
	
	if (self->health <(self->max_health / 2))
		self->s.skinnum = 1;
	
	if (level.time < self->pain_debounce_time)
		return;
	
	self->pain_debounce_time = level.time + 3;
	if (CVAR_SKILL == NIGHTMARE_MODE)
		return;    // no pain anims in NIGHTMARE_MODE
	
	n = rand()%3;
	if (n == 0) {
		gi.sound(self, CHAN_VOICE, sound_pain1, 1, ATTN_NORM, 0);
		self->monsterinfo.currentmove = &flyer_move_pain1; }
	else if (n == 1) {
		gi.sound(self, CHAN_VOICE, sound_pain2, 1, ATTN_NORM, 0);
		self->monsterinfo.currentmove = &flyer_move_pain2; }
	else {
		gi.sound(self, CHAN_VOICE, sound_pain1, 1, ATTN_NORM, 0);
		self->monsterinfo.currentmove = &flyer_move_pain3; }
}

//============================================================
void flyer_die(edict_t *self, edict_t *inflictor, edict_t *attacker, int damage, vec3_t point) {
	
	// Rider for this Flyer?
	if (self->rider) {
		gi_centerprintf(self->rider,"FLYER DESTROYED\n");
		self->rider->flyer=NULL;
		self->rider->is_riding=false;
		self->rider->target_my_enemy=false;
		gi.linkentity(self->rider); } // Immediately update world()..
	
	// Play flyer death sound...
	gi.sound(self, CHAN_VOICE, sound_die, 1, ATTN_NORM, 0);
	
	BecomeExplosion1(self);
}

//============================================================
void SP_monster_flyer(edict_t *self) {
	
	if (deathmatch->value) {
		G_FreeEdict(self);
		return; }
	
	// fix a map bug in jail5.bsp
	if (!Q_stricmp(level.mapname, "jail5") && (self->s.origin[2] == -104)) {
		self->targetname = self->target;
		self->target = NULL; }
	
	sound_sight = gi.soundindex("flyer/flysght1.wav");
	sound_idle = gi.soundindex("flyer/flysrch1.wav");
	sound_pain1 = gi.soundindex("flyer/flypain1.wav");
	sound_pain2 = gi.soundindex("flyer/flypain2.wav");
	sound_slash = gi.soundindex("flyer/flyatck2.wav");
	sound_sproing = gi.soundindex("flyer/flyatck1.wav");
	sound_die = gi.soundindex("flyer/flydeth1.wav");
	
	gi.soundindex("flyer/flyatck3.wav");
	
	self->s.modelindex = gi.modelindex("models/monsters/flyer/tris.md2");
	VectorSet(self->mins, -16, -16, -24);
	VectorSet(self->maxs, 16, 16, 32);
	self->movetype = MOVETYPE_STEP;
	self->solid = SOLID_BBOX;
	
	self->s.sound = gi.soundindex("flyer/flyidle1.wav");
	
	self->health = 50;
	self->mass = 50;
	
	self->pain = flyer_pain;
	self->die = flyer_die;
	
	self->monsterinfo.stand = flyer_stand;
	self->monsterinfo.walk = flyer_walk;
	self->monsterinfo.run = flyer_run;
	self->monsterinfo.attack = flyer_attack;
	self->monsterinfo.melee = flyer_melee;
	self->monsterinfo.sight = flyer_sight;
	self->monsterinfo.idle = flyer_idle;
	
	self->monsterinfo.currentmove = &flyer_move_stand;
	
	self->monsterinfo.scale = MODEL_SCALE;
	
	gi.linkentity(self);
	
	flymonster_start(self);
}

//======================================================
//=============== FLYER ROUTINES =======================
//======================================================

//======================================================
void Teleport_Now(edict_t *ent) {
	vec3_t spawn_origin;
	vec3_t spawn_angles;
	vec3_t up;
	
	VectorSet(spawn_origin,0,0,0);
	VectorSet(spawn_angles,0,0,0);
	
	// Large particle effect at player's old spot
	G_Spawn_Splash(TE_LASER_SPARKS, 24, 0xe2e5e3e6, ent->s.origin, zvec, ent->s.origin);
	
	// Ent wants to jump onto the Flyer?
	if (ent->flyer && !ent->is_riding) {
		// Drop ent slightly above the top of Flyer.
		AngleVectors(ent->flyer->s.angles, NULL, NULL, up);
		VectorMA(ent->flyer->s.origin, 15, up, ent->s.origin);
		// Facing in the same direction as Flyer.
		VectorCopy(ent->flyer->s.angles, ent->s.angles);
		ent->is_riding=true; }
	else {
		ent->is_riding=false;
		ent->target_my_enemy=false; // can't target if not riding..
		SelectSpawnPoint(ent, spawn_origin, spawn_angles);
		ent->client->ps.pmove.origin[0] = spawn_origin[0]*8;
		ent->client->ps.pmove.origin[1] = spawn_origin[1]*8;
		ent->client->ps.pmove.origin[2] = spawn_origin[2]*8;
		VectorCopy(spawn_origin, ent->s.origin); }
	
	// Teleport particle effect at ent's new origin.
	ent->s.event = EV_PLAYER_TELEPORT;
	
	// play teleport sound effects.
	gi.sound(ent, CHAN_VOICE, gi.soundindex("misc/tele1.wav"), 1, ATTN_NORM, 0);
}

//======================================================
// Owner = timer->owner
// Flyer = timer->owner->flyer
//======================================================
void Flyer_Explode(edict_t *timer) {
	
	if (timer->owner->flyer)
		T_Damage(timer->owner->flyer, timer->owner, timer->owner, zvec, timer->owner->flyer->s.origin, NULL, 500, 1, 0, MOD_SPLASH);
	
	G_FreeEdict(timer);
}

//======================================================
void Timer_Think(edict_t *timer) {
	
	if (timer->delay - 10 <= level.time) {
		gi_centerprintf(timer->owner,"10 SECONDS TO DETONATION\n");
		timer->think=Flyer_Explode;
		timer->nextthink = level.time + 10.0; } // 10 secs left!!
	else
		timer->nextthink = level.time + 1.0;
}

//======================================================
void Reset_Effects(edict_t *timer) {
	
	// Restore some of Flyer's states.
	timer->owner->flyer->s.effects=EF_NONE; // Turn Off particle trail
	
	// Set Timer to do its thing
	timer->delay = level.time + 170.0; // When to notify Rider..
	timer->think=Timer_Think;
	timer->nextthink=level.time + 1.0;
}

//=========================================================
void Spawn_Flyer(edict_t *ent) {
	edict_t *flyer, *timer;
	vec3_t forward, up, torigin;
	int temp;
	
	// Start power-up launch sound now..
	gi.sound(ent, CHAN_VOICE, POWER1_SOUND, 1, ATTN_IDLE, 0);
	
	AngleVectors(ent->s.angles, forward, NULL, up);
	VectorCopy(ent->s.origin, torigin);
	VectorMA(torigin, 25, forward, torigin);
	
	// Create basic entity stuff...
	flyer = G_Spawn();
	flyer->classname = "XFlyer";
	flyer->rider = ent;// Link back to Owner.
	VectorCopy(torigin, flyer->s.origin);
	gi.linkentity(flyer);
	
	//
	// Now for the Flyer's stuff..
	//
	
	temp=deathmatch->value;
	deathmatch->value=0;
	
	// Force skill to NIGHTMARE MODE - hehe!!
	gi.cvar_forceset("skill", va("%f","3"));
	
	// Bat-like monster with wings
	SP_monster_flyer(flyer);
	
	deathmatch->value=temp; // Restore to previous value.
	
	// Make some subtle changes to Flyer's properties..
	flyer->monsterinfo.aiflags &= AI_BRUTAL;
	flyer->health = 150;
	flyer->monsterinfo.power_armor_type = POWER_ARMOR_SCREEN;
	flyer->monsterinfo.power_armor_power = 100;
	
	// Physically throw the Flyer forward and up!
	flyer->s.effects=EF_ROCKET;
	VectorCopy(ent->s.angles, flyer->s.angles);
	VectorCopy(forward, flyer->movedir);
	VectorClear(flyer->velocity);
	VectorMA(flyer->velocity, 800, forward, flyer->velocity);
	VectorMA(flyer->velocity, 200, up, flyer->velocity);
	
	timer=G_Spawn();
	timer->owner=ent; // Link timer to Owner
	timer->takedamage=DAMAGE_NO;
	timer->solid = SOLID_NOT;
	timer->movetype=MOVETYPE_NONE;
	VectorClear(timer->s.origin);
	VectorClear(timer->mins);
	VectorClear(timer->maxs);
	timer->think=Reset_Effects;
	timer->nextthink=level.time + 0.5;  // In 1/2 sec turn off effects;
	gi.linkentity(timer);
	
	ent->flyer = flyer;  // Link ent to this Flyer.
	ent->mynoise2=timer; // Link back to timer..
}

//======================================================
// Pay the Piper for your Radio Flyer
//======================================================
void Cmd_Flyer_f(edict_t *ent) {
	int index;
	
	// Don't allow dead/respawning players to do this!
	if (!G_ClientInGame(ent)) return;
	
	// Only 1 Flyer per customer.
	if (ent->flyer) {
		Teleport_Now(ent);
		return; }
	
	// Well.. Make the damn thing already!
	if (deathmatch->value) {
		// Check if ent has any powercells at all..
		index = ITEM_INDEX(item_cells);
		// If not enough cells or not enough frags then notify ent..
		if ((ent->client->pers.inventory[index] < 50) && (ent->client->resp.score < 3)){
			gi_centerprintf(ent, "Flyer requires 50 PowerCells\n\nor 3 Frags to Launch!");
			return; }
		// Try to deduct the powercells first!
		if (ent->client->pers.inventory[index] >= 50) {
			ent->client->pers.inventory[index] -= 50;
			Spawn_Flyer(ent);
			return; }
		// Otherwise, if ent has enough frags,
		if (ent->client->resp.score >= 3) {
			ent->client->resp.score -= 3;
			Spawn_Flyer(ent);
			return; } }
	else {
		// Single-Player price
		if (ent->health < 25)
			gi_centerprintf(ent, "Flyer costs 25 Health Units\n!");
		else {
			ent->health -= 25;
			Spawn_Flyer(ent); } }
}
